#include <Ethernet.h>
#include <EthernetUdp.h>
#include <SPI.h>    
#include <OSCBundle.h>
#include <Encoder.h>

EthernetUDP Udp;

// CONFIGURATION of the arduino

byte mac[] = { 0x90, 0xA2, 0xDA, 0x0E, 0xD2, 0xC4 }; 

byte ip[]      = { 192, 168,   1, 77}; //the Arduino's IP
byte gateway[] = { 192, 168,   1, 1}; 
byte subnet[]  = { 255, 255, 255, 0}; 
byte outIp[]   = { 192, 168,   1, 226}; //destination IP

char* name = "links"; // the identifier of the arduino

// END CONFIGURATION

Encoder myEnc(2, 3); //   Best Performance: both pins have interrupt capability
unsigned int outPort = 9999;

void setup() {
  Ethernet.begin(mac,ip);
  Udp.begin(outPort);
  Serial.begin(19200);
}

void loop(){
//    Serial.write("Test\n");
    OSCBundle bndl;

    //BOSCBundle's add' returns the OSCMessage so the message's 'add' can be composed together
    bndl.add("/name").add(name);
    bndl.add("/rotary").add((int32_t)myEnc.read()); // you can rotate from -2billion to +2billion
    bndl.add("/poti").add((int32_t)analogRead(0));  // 0 - 1023
 
    bndl.add("/button0").add(digitalRead(5)==HIGH?1:0);
    bndl.add("/button1").add(digitalRead(6)==HIGH?1:0);
    bndl.add("/button2").add(digitalRead(7)==HIGH?1:0);

    Udp.beginPacket(outIp, outPort);
    bndl.send(Udp); // send the bytes to the SLIP stream
    Udp.endPacket(); // mark the end of the OSC Packet

    bndl.empty(); // empty the bundle to free room for a new one

}
