#include <Ethernet.h>
#include <EthernetUdp.h>
#include <SPI.h>    
#include <OSCBundle.h>
#include <Encoder.h>

// NETWORK CONFIGURATION 
byte mac[] = { 0x90, 0xa2, 0xda, 0x0e, 0xd2, 0xc4 }; 
IPAddress ip(192, 168, 2, 77); //the Arduino's IP
IPAddress outIp(192, 168, 2, 226); //destination IP
const unsigned int outPort = 8888;
char* name = "rechts"; // the identifier of the arduino

// STREAM CONFIGURATION
EthernetUDP Udp;

#ifdef BOARD_HAS_USB_SERIAL
#include <SLIPEncodedUSBSerial.h>
SLIPEncodedUSBSerial SLIPSerial( thisBoardsSerialUSB );
#else
#include <SLIPEncodedSerial.h>
 SLIPEncodedSerial SLIPSerial(Serial);
#endif

// PIN CONFIGURATION
Encoder myEnc(2, 3); //   Best Performance: both pins have interrupt capability
int buttonPin[] = {6,7, 8,9}; // digital
int potiPin = 0; // analog

void setup() {
//  Ethernet.begin(mac,ip);
  
  SLIPSerial.begin(19200);   // set this as high as you can reliably run on your platform
  pinMode(buttonPin[0], INPUT_PULLUP);
  pinMode(buttonPin[1], INPUT_PULLUP);
  pinMode(buttonPin[2], INPUT_PULLUP);
  pinMode(buttonPin[3], INPUT_PULLUP);

}

void loop(){
    OSCBundle bndl;

    //BOSCBundle's add' returns the OSCMessage so the message's 'add' can be composed together
    bndl.add("/name").add(name);
    bndl.add("/rotary").add((int32_t)myEnc.read()); // you can rotate from -2billion to +2billion
    bndl.add("/poti").add((int32_t)analogRead(potiPin));  // 0 - 1023
 
    boolean high = LOW; // flip because of INPUT_PULLUP
//    bndl.add("/button0").add(digitalRead(buttonPin[0])==high?1:0);
//    bndl.add("/button1").add(digitalRead(buttonPin[1])==high?1:0);
 //   bndl.add("/button2").add(digitalRead(buttonPin[2])==high?1:0);
 //   bndl.add("/button3").add(digitalRead(buttonPin[3])==high?1:0);

  SLIPSerial.beginPacket();
  bndl.send(SLIPSerial); // send the bytes to the SLIP stream
  SLIPSerial.endPacket(); // mark the end of the OSC Packet

//    Udp.beginPacket(outIp, outPort);        
//    bndl.send(Udp); // send the bytes to the SLIP stream
//    Udp.write("ack");
 //   Udp.endPacket(); // mark the end of the OSC Packet

    bndl.empty(); // empty the bundle to free room for a new one

}
